#include "AppDelegate.h"
#include "HelloWorldScene.h"

USING_NS_CC;

AppDelegate::AppDelegate() {

}

AppDelegate::~AppDelegate() 
{
}

//if you want a different context,just modify the value of glContextAttrs
//it will takes effect on all platforms
void AppDelegate::initGLContextAttrs()
{
    //set OpenGL context attributions,now can only set six attributions:
    //red,green,blue,alpha,depth,stencil
    GLContextAttrs glContextAttrs = {8, 8, 8, 8, 24, 8};

    GLView::setGLContextAttrs(glContextAttrs);
}

typedef struct tagResource
{
    Size size;
    char directory[100];
}Resource;

static Size designResolutionSize = Size(320, 480);
static Resource smallResource = { Size(320, 480), "iphone" };
static Resource mediumResource = { Size(640, 960), "iphone_retina" };

bool AppDelegate::applicationDidFinishLaunching() {
    // initialize director
    auto director = Director::getInstance();
    auto glview = director->getOpenGLView();
    if(!glview) {
        glview = GLViewImpl::createWithRect("My Game", Rect(0, 0, designResolutionSize.width, designResolutionSize.height));
        director->setOpenGLView(glview);
    }

    // Set the design resolution
    glview->setDesignResolutionSize(designResolutionSize.width, designResolutionSize.height, ResolutionPolicy::SHOW_ALL);

    Size frameSize = glview->getFrameSize();

    // frameSize smallResource ۰ų  smallResource Ѵ.
    std::vector<std::string> resDirOrders;
    if (frameSize.height <= smallResource.size.height){
        resDirOrders.push_back(smallResource.directory);
        director->setContentScaleFactor(smallResource.size.height / designResolutionSize.height);
    }
    // frameSize smallResource ũ  mediumResource Ѵ.
    else{
        resDirOrders.push_back(mediumResource.directory);
        director->setContentScaleFactor(mediumResource.size.height / designResolutionSize.height);
    }

    FileUtils::getInstance()->setSearchResolutionsOrder(resDirOrders);

    // turn on display FPS
    director->setDisplayStats(true);

    // set FPS. the default value is 1.0/60 if you don't call this
    director->setAnimationInterval(1.0 / 60);

    // create a scene. it's an autorelease object
    auto scene = HelloWorld::createScene();

    // run
    director->runWithScene(scene);

    return true;
}

// This function will be called when the app is inactive. When comes a phone call,it's be invoked too
void AppDelegate::applicationDidEnterBackground() {
    Director::getInstance()->stopAnimation();

    // if you use SimpleAudioEngine, it must be pause
    // SimpleAudioEngine::getInstance()->pauseBackgroundMusic();
}

// this function will be called when the app is active again
void AppDelegate::applicationWillEnterForeground() {
    Director::getInstance()->startAnimation();

    // if you use SimpleAudioEngine, it must resume here
    // SimpleAudioEngine::getInstance()->resumeBackgroundMusic();
}
