#include "StartScene.h"
#include "CharacterScene.h"

USING_NS_CC;

Scene* StartScene::createScene()
{
    // 'scene' is an autorelease object
    auto scene = Scene::create();

    // 'layer' is an autorelease object
    auto layer = StartScene::create();

    // add layer as a child to scene
    scene->addChild(layer);

    // return the scene
    return scene;
}

// on "init" you need to initialize your instance
bool StartScene::init()
{
    //////////////////////////////
    // 1. super init first
    if (!Layer::init())
    {
        return false;
    }

    //code Here
    /*****Device ũ⸦ ɴϴ.*****/
    //Director ɴϴ.
    auto director = Director::getInstance();
    //OpenGLView ɴϴ.
    auto glview = director->getOpenGLView();
    //OpenGLView DesignResolutionSize ɴϴ.
    auto winSize = glview->getDesignResolutionSize();
    /*****Device ũ⸦ ɴϴ.*****/

    //Sprite Ͽ ̹ ҷɴϴ.
    auto back = Sprite::create("title_bg.png");

    //back ش Ʈ ġŵϴ. ȭ ߾ӿ ġϵ ߽ϴ.
    back->setPosition(Point(winSize.width / 2, winSize.height / 2));

    //this back ڽNode ߰Ͽϴ.
    this->addChild(back);

    //Title ߰
    auto title = Sprite::create("title_text.png");

    //AnchorPoint Point(0.5f, 1) 
    title->setAnchorPoint(Point(0.5f, 1));

    //back ش Ʈ ġŵϴ. ȭ ߾ӿ ġϵ ߽ϴ.
    title->setPosition(Point(winSize.width / 2, winSize.height - 30));

    //this back ڽNode ߰Ͽϴ.
    this->addChild(title);

    //ĳ ߰
    auto character = Sprite::create("title_character.png");

    //character ش Ʈ ġŵϴ. ȭ ߾ӿ ġϵ ߽ϴ.
    character->setPosition(Point(winSize.width / 2, winSize.height / 2));

    //this character ڽNode ߰Ͽϴ.
    this->addChild(character);

    //ư ߰
    auto button1 = MenuItemImage::create("title_btn_1.png", "title_btn_1_on.png", "title_btn_1_dis.png", [&](Ref *sender) {
        log("onClickButton1");
        //ȭ ȯ ϸ̼ ϰ   ִ.
        //auto Scene = TransitionFlipX::create(0.5f, CharacterScene::createScene()); 
        //auto Scene = TransitionFlipY::create (0.5f, CharacterScene::createScene()); 
        //auto Scene = TransitionJumpZoom::create(0.5f, CharacterScene::createScene()); 
        auto Scene = TransitionCrossFade::create(10.5f, CharacterScene::createScene());
        Director::getInstance()->pushScene(Scene);
    });

    button1->setEnabled(true);
    button1->setPosition(Point(winSize.width / 2, 100));

    auto button2 = MenuItemImage::create("title_btn_2.png", "title_btn_2_on.png", CC_CALLBACK_1(StartScene::onClickButton2, this));
    button2->setPosition(Point(winSize.width / 2, 40));

    // ư ޴ ߰Ѵ.
    auto menu = Menu::create(button1, button2, NULL);
    menu->setPosition(Point::ZERO);
    this->addChild(menu);

    return true;
}

void StartScene::onClickButton2(Ref *object){
    log("onClickButton2");

    //%s String ޾Ƽ մϴ.
    log("%s", "string test");

    //log()  Ķ͸   ֽϴ.
    log("%s / %s", "string test1", "string test2");

    //%d int մϴ.
    log("%d", 1234567890);

    //%f float ޾  մϴ.
    log("%f", 1234.56789f);

    //   ֽϴ. 
    log("%s / %d / %f", "test", 123, 0.25f);
}
