#include "CharacterScene.h"
#include "DatabaseManager.h"
#include "DevConf.h"

USING_NS_CC;

Scene* CharacterScene::createScene()
{
    // 'scene' is an autorelease object
    auto scene = Scene::create();

    // 'layer' is an autorelease object
    auto layer = CharacterScene::create();

    // add layer as a child to scene
    scene->addChild(layer);

    // return the scene
    return scene;
}

CharacterScene::CharacterScene(){
    //ü ʱȭ
    _face = NULL;
    _hair1 = NULL;
    _hair2 = NULL;
    _eye = NULL;
    _mouth = NULL;
    _etc = NULL;
    _bgStyle = NULL;
    _balloon = NULL;
    _arrow = NULL;
}

CharacterScene::~CharacterScene(){

}

// on "init" you need to initialize your instance
bool CharacterScene::init()
{
    //////////////////////////////
    // 1. super init first
    if (!Layer::init())
    {
        return false;
    }

    //code here

    //UserDefault ɴϴ.
    auto UserDefault = UserDefault::getInstance();
    //UserDefault isFirst  ɴϴ.
    bool isFirst = UserDefault->getBoolForKey("isFirst", true);
    if (isFirst || DB_INIT){
        DatabaseManager::getInstance()->createDB();
        DatabaseManager::getInstance()->insertDB();

        //isFirst  մϴ.
        UserDefault->setBoolForKey("isFirst", false);
        //UserDefault  Ͽ flush() ȣ־ ˴ϴ.
        UserDefault->flush();
    }

    /*****Device ũ⸦ ɴϴ.*****/
    //Director ɴϴ.
    auto director = Director::getInstance();
    //OpenGLView ɴϴ.
    auto glView = director->getOpenGLView();
    //OpenGLView DesignResolutionSize ɴϴ.
    auto winSize = glView->getDesignResolutionSize();
    /*****Device ũ⸦ ɴϴ.*****/

    // ߰
    auto back = Sprite::create("bg_main.png");
    back->setPosition(Point(winSize.width / 2, winSize.height / 2));
    this->addChild(back);

    //ĳ ڽ ߰
    _characterBg = Sprite::create("bg_1.png");
    //Node  ߾ . setAnchorPoint  0~1. 1 100%Դϴ.
    _characterBg->setAnchorPoint(Point(0.5, 1));
    //AnchorPoint  ߾ Ͽ ܿ 15pxŭ Ʒ ȴ.
    _characterBg->setPosition(Point(winSize.width / 2, winSize.height - 15));
    //back ڽĳ ߰
    back->addChild(_characterBg);

    //ĳ UI  ư ߰
    auto menu1Face = MenuItemImage::create("btn_face.png", "btn_face_on.png", CC_CALLBACK_1(CharacterScene::onClickMenu, this));
    menu1Face->setPosition(Point(25, 125));

    auto menu1Hair1 = MenuItemImage::create("btn_hair1.png", "btn_hair1_on.png", CC_CALLBACK_1(CharacterScene::onClickMenu, this));
    menu1Hair1->setPosition(Point(70, 125));

    auto menu1Hair2 = MenuItemImage::create("btn_hair2.png", "btn_hair2_on.png", CC_CALLBACK_1(CharacterScene::onClickMenu, this));
    menu1Hair2->setPosition(Point(115, 125));

    auto menu1Eye = MenuItemImage::create("btn_eye.png", "btn_eye_on.png", CC_CALLBACK_1(CharacterScene::onClickMenu, this));
    menu1Eye->setPosition(Point(160, 125));

    auto menu1Mouth = MenuItemImage::create("btn_mouth.png", "btn_mouth_on.png", CC_CALLBACK_1(CharacterScene::onClickMenu, this));
    menu1Mouth->setPosition(Point(205, 125));

    auto menu1Etc = MenuItemImage::create("btn_etc.png", "btn_etc_on.png", CC_CALLBACK_1(CharacterScene::onClickMenu, this));
    menu1Etc->setPosition(Point(250, 125));

    auto menu1Bg = MenuItemImage::create("btn_bg.png", "btn_bg_on.png", CC_CALLBACK_1(CharacterScene::onClickMenu, this));
    menu1Bg->setPosition(Point(295, 125));

    auto menu1 = Menu::create(menu1Face, menu1Hair1, menu1Hair2, menu1Eye, menu1Mouth, menu1Etc, menu1Bg, NULL);
    menu1->setPosition(Point::ZERO);
    this->addChild(menu1);

    // MenuItemImage ± 
    menu1Face->setTag(1);
    menu1Hair1->setTag(2);
    menu1Hair2->setTag(3);
    menu1Eye->setTag(4);
    menu1Mouth->setTag(5);
    menu1Etc->setTag(6);
    menu1Bg->setTag(7);

    //ϴ ޴ ư ǥ  ũ 
    float x;
    float y;
    float width;
    float height;

    //ϴ ޴ ư ߰
    auto menu2Home = MenuItemImage::create("menu_home.png", "menu_home_on.png", CC_CALLBACK_1(CharacterScene::onClickHome, this));
    width = menu2Home->getContentSize().width;
    height = menu2Home->getContentSize().height;
    x = width / 2;
    y = height / 2;
    menu2Home->setPosition(Point(x, y));

    auto menu2Random = MenuItemImage::create("menu_random.png", "menu_random_on.png", CC_CALLBACK_1(CharacterScene::onClickRandom, this));
    x = menu2Home->getPositionX() + width;
    menu2Random->setPosition(Point(x, y));

    auto menu2Save = MenuItemImage::create("menu_save.png", "menu_save_on.png", CC_CALLBACK_1(CharacterScene::onClickSave, this));
    x = menu2Random->getPositionX() + width;
    menu2Save->setPosition(Point(x, y));

    auto menu2Gallery = MenuItemImage::create("menu_gallary.png", "menu_gallary_on.png", CC_CALLBACK_1(CharacterScene::onClickGallery, this));
    x = menu2Save->getPositionX() + width;
    menu2Gallery->setPosition(Point(x, y));

    auto menu2 = Menu::create(menu2Home, menu2Random, menu2Save, menu2Gallery, NULL);
    menu2->setPosition(Point::ZERO);
    this->addChild(menu2);

    setImage("TB_FACE", -1, -1);
    setImage("TB_HAIR1", -1, -1);
    setImage("TB_HAIR2", -1, -1);
    setImage("TB_EYE", -1, -1);
    setImage("TB_MOUTH", -1, -1);
    setImage("TB_ETC", -1, -1);
    setImage("TB_BG", -1, -1);

    //1 ⺻ õǵ
    setBalloon(1);

    return true;
}

void CharacterScene::onClickMenu(Ref *object){
    log("onClickMenu");
    //sender ü Node ĳϿ ±׸ ´.
    setBalloon(((Node *)object)->getTag());
}

void CharacterScene::onClickHome(Ref *object){
    log("onClickHome");
    Director::getInstance()->popScene();
}

void CharacterScene::onClickRandom(Ref *object){
    log("onClickRandom");
    setImage("TB_FACE", -1, -1);
    setImage("TB_HAIR1", -1, -1);
    setImage("TB_HAIR2", -1, -1);
    setImage("TB_EYE", -1, -1);
    setImage("TB_MOUTH", -1, -1);
    setImage("TB_ETC", -1, -1);
    setImage("TB_BG", -1, -1);
}

void CharacterScene::onClickSave(Ref *object){
    log("onClickSave");
}

void CharacterScene::onClickGallery(Ref *object){
    log("onClickGallery");
}

void CharacterScene::setImage(std::string tableName, int rowNo, int colorNo){
    //ĶͿ  headList ´.
    auto headList = DatabaseManager::getInstance()->selectDB(tableName, rowNo);

    //ù° ü , setImage() ̿ϸ ϳ row ȯ˴ϴ.
    auto head = headList.front();

    //zOrder 
    int zOrder = 0;

    if (tableName == "TB_FACE"){
        //_face NULL ƴϸ
        if (_face != NULL){
            //θκ ڱ⸦ 
            _face->removeFromParentAndCleanup(true);
        }

        zOrder = 2;

        //ͺ̽ ̹ ϸ ش  ǥ  ġŲ.
        _face = Sprite::create(head->image);
        _face->setPosition(head->position);
        _characterBg->addChild(_face, zOrder);
    }
    else if (tableName == "TB_HAIR1"){
        if (_hair1 != NULL){
            _hair1->removeFromParentAndCleanup(true);
        }

        zOrder = 4;
        _hair1 = Sprite::create(head->image);
        _hair1->setPosition(head->position);
        _characterBg->addChild(_hair1, zOrder);
    }
    else if (tableName == "TB_HAIR2"){
        if (_hair2 != NULL){
            _hair2->removeFromParentAndCleanup(true);
        }

        zOrder = 1;
        _hair2 = Sprite::create(head->image);
        _hair2->setPosition(head->position);
        _characterBg->addChild(_hair2, zOrder);
    }
    else if (tableName == "TB_EYE"){
        if (_eye != NULL){
            _eye->removeFromParentAndCleanup(true);
        }

        zOrder = 3;
        _eye = Sprite::create(head->image);
        _eye->setPosition(head->position);
        _characterBg->addChild(_eye, zOrder);
    }
    else if (tableName == "TB_MOUTH"){
        if (_mouth != NULL){
            _mouth->removeFromParentAndCleanup(true);
        }

        zOrder = 3;
        _mouth = Sprite::create(head->image);
        _mouth->setPosition(head->position);
        _characterBg->addChild(_mouth, zOrder);
    }
    else if (tableName == "TB_ETC"){
        if (_etc != NULL){
            _etc->removeFromParentAndCleanup(true);
        }

        zOrder = 5;
        _etc = Sprite::create(head->image);
        _etc->setPosition(head->position);
        _characterBg->addChild(_etc, zOrder);
    }
    else if (tableName == "TB_BG"){
        if (_bgStyle != NULL){
            _bgStyle->removeFromParentAndCleanup(true);
        }

        zOrder = 0;
        _bgStyle = Sprite::create(head->image);
        _bgStyle->setPosition(head->position);
        _characterBg->addChild(_bgStyle, zOrder);
    }

	if (head->isColor){
		Color3B color;

		if (colorNo < 0){
			//srand rand صǴ      ݺȴ.
			srand(time(NULL));
			//1~4  ϰ ߻Ŵ
			colorNo = rand() % 4 + 1;
		}

		switch (colorNo)
		{
		case 1:
			color = head->color1;
			break;
		case 2:
			color = head->color2;
			break;
		case 3:
			color = head->color3;
			break;
		case 4:
			color = head->color4;
			break;
		}

		if (tableName == "TB_FACE")
			_face->setColor(color);
		else if (tableName == "TB_HAIR1")
			_hair1->setColor(color);
		else if (tableName == "TB_HAIR2")
			_hair2->setColor(color);
		else if (tableName == "TB_EYE")
			_eye->setColor(color);
		else if (tableName == "TB_MOUTH")
			_mouth->setColor(color);
		else if (tableName == "TB_ETC")
			_etc->setColor(color);
		else if (tableName == "TB_BG")
			_bgStyle->setColor(color);

	}
}

void CharacterScene::setBalloon(int position){
    if (_arrow == NULL){
        //Device ũ⸦ ɴϴ.
        auto winSize = Director::getInstance()->getOpenGLView()->getDesignResolutionSize();

        _balloon = Sprite::create("box_list.png");
        _balloon->setPosition(Point(winSize.width / 2, 75));
        this->addChild(_balloon, 1);

        _arrow = Sprite::create("box_list2.png");
        //ǳ ܿ  ̱  ȭǥ ϴ   ־.
        _arrow->setAnchorPoint(Point(0.5, 0));
        _balloon->addChild(_arrow);
    }

    Point arrowPoint;
    switch (position)
    {
    case 1:
        arrowPoint = Point(22, _balloon->getContentSize().height);
        break;
    case 2:
        arrowPoint = Point(68, _balloon->getContentSize().height);
        break;
    case 3:
        arrowPoint = Point(113, _balloon->getContentSize().height);
        break;
    case 4:
        arrowPoint = Point(158, _balloon->getContentSize().height);
        break;
    case 5:
        arrowPoint = Point(203, _balloon->getContentSize().height);
        break;
    case 6:
        arrowPoint = Point(248, _balloon->getContentSize().height);
        break;
    case 7:
        arrowPoint = Point(293, _balloon->getContentSize().height);
        break;
    }

    _arrow->setPosition(arrowPoint);
}