#include "GalleryScene.h"
#include "StartScene.h"

USING_NS_CC;

Scene* GalleryScene::createScene()
{
    // 'scene' is an autorelease object
    auto scene = Scene::create();

    // 'layer' is an autorelease object
    auto layer = GalleryScene::create();

    // add layer as a child to scene
    scene->addChild(layer);

    // return the scene
    return scene;
}

// on "init" you need to initialize your instance
bool GalleryScene::init()
{
    //////////////////////////////
    // 1. super init first
    if (!Layer::init())
    {
        return false;
    }

    //code here

    //Device ũ⸦ ɴϴ.
    Size winSize = Director::getInstance()->getOpenGLView()->getDesignResolutionSize();

    //Sprite Ͽ ̹ ҷɴϴ.
    auto back = Sprite::create("bg_gallery.png");
    //back ش Ʈ ġŵϴ. ȭ ߾ӿ ġϵ ߽ϴ.
    back->setPosition(Point(winSize.width / 2, winSize.height / 2));

    //this back ڽNode ߰Ͽϴ.
    this->addChild(back);

    auto home = MenuItemImage::create("menu_home2.png", "menu_home2_on.png", CC_CALLBACK_1(GalleryScene::onClickHome, this));
    home->setAnchorPoint(Point(0, 0));
    home->setPosition(Point(0, 0));

    auto make = MenuItemImage::create("menu_make.png", "menu_make_on.png", CC_CALLBACK_1(GalleryScene::onClickMake, this));
    make->setAnchorPoint(Point(1, 0));
    make->setPosition(Point(winSize.width, 0));

    auto menu2 = Menu::create(home, make, NULL);
    menu2->setPosition(Point::ZERO);
    this->addChild(menu2);

    return true;
}

void GalleryScene::onClickHome(Ref *object){
    log("onClickHome");
    auto Scene = StartScene::createScene();
    //StartScene ̵ϴµ  Scene StartScene ƿ ʱ⿡ replaceScene 
    Director::getInstance()->replaceScene(Scene);
}

void GalleryScene::onClickMake(Ref *object){
    log("onClickMake");
    //ȭ ĳ  ȭ̹Ƿ  Scene Director popѴ.
    Director::getInstance()->popScene();
}
