#include "GameScene.h"

USING_NS_CC;

Scene* GameScene::createScene()
{
    // 'scene' is an autorelease object
    auto scene = Scene::create();

    // 'layer' is an autorelease object
    auto layer = GameScene::create();

    // add layer as a child to scene
    scene->addChild(layer);

    // return the scene
    return scene;
}

// on "init" you need to initialize your instance
bool GameScene::init()
{
    //////////////////////////////
    // 1. super init first
    if (!Layer::init())
    {
        return false;
    }

    //code here

    Size winSize = Director::getInstance()->getOpenGLView()->getDesignResolutionSize();

    //
    auto bg = Sprite::create("game_bg.png");
    bg->setPosition(Point(winSize.width / 2, winSize.height / 2));
    this->addChild(bg);

    //ŸƲ
    auto title = Sprite::create("game_title.png");
    title->setPosition(Point(winSize.width / 2, winSize.height - 20));
    this->addChild(title);

    //ư ư
    auto back = MenuItemImage::create("btn_back.png", "btn_back_on.png", CC_CALLBACK_1(GameScene::onClickBack, this));
    back->setPosition(Point(30, winSize.height - 20));

    auto menu = Menu::create(back, NULL);
    menu->setPosition(Point::ZERO);
    this->addChild(menu);

    //ھ â
    auto score = Sprite::create("box_scroe.png");
    score->setPosition(Point(250, 410));
    this->addChild(score);

    //ھ ǥ Label
    _labelScore = LabelTTF::create("0", "arial", 20);
    _labelScore->setPosition(Point(score->getContentSize().width / 2, 22));
    //score Sprite ߰־.
    score->addChild(_labelScore);

    return true;
}

void GameScene::onClickBack(Ref* object)
{
    log("onClickBack");
    Director::getInstance()->popScene();
}
