#include "StartScene.h"
#include "BackgroundLayer.h"

USING_NS_CC;

Scene* StartScene::createScene()
{
    // 'scene' is an autorelease object
    auto scene = Scene::create();

    // 'layer' is an autorelease object
    auto layer = StartScene::create();

    // add layer as a child to scene
    scene->addChild(layer);

    // return the scene
    return scene;
}

// on "init" you need to initialize your instance
bool StartScene::init()
{
    //////////////////////////////
    // 1. super init first
    if (!Layer::init())
    {
        return false;
    }

    //code here
    //Device ũ⸦ ɴϴ.
    auto winSize = Director::getInstance()->getOpenGLView()->getDesignResolutionSize();

    this->addChild(BackgroundLayer::create());

    auto title = Sprite::create("title_1.png");
    title->setPosition(Point(winSize.width / 2, 230));
    this->addChild(title);

    auto deco = Sprite::create("intro_bear1.png");
    deco->setAnchorPoint(Point(1, 0));
    deco->setPosition(Point(winSize.width, 0));
    this->addChild(deco);

    auto gameMenu = MenuItemImage::create("btn_play.png", "btn_play_on.png", CC_CALLBACK_1(StartScene::onClickGame, this));
    gameMenu->setPosition(Point(winSize.width / 2, 130));
    auto rankMenu = MenuItemImage::create("btn_ranking.png", "btn_ranking_on.png", CC_CALLBACK_1(StartScene::onClickRank, this));
    rankMenu->setPosition(Point(winSize.width / 2, 70));

    auto menu = Menu::create(gameMenu, rankMenu, NULL);
    menu->setPosition(Point::ZERO);
    this->addChild(menu);

    return true;
}

void StartScene::onClickGame(Ref *object){
    log("onClickGame");
}

void StartScene::onClickRank(Ref *object){
    log("onClickRank");
}
