#include "GameScene.h"
#include "BackgroundLayer.h"

// Ķ͸  
static Node *_stageScene;
static int _stage;

Scene* GameScene::createScene(Node *stageScene, int stage)
{
    _stageScene = stageScene;
    _stage = stage;

    // 'scene' is an autorelease object
    auto scene = Scene::create();

    // 'layer' is an autorelease object
    auto layer = GameScene::create();

    // add layer as a child to scene
    scene->addChild(layer);

    // return the scene
    return scene;
}

// on "init" you need to initialize your instance
bool GameScene::init()
{
    //////////////////////////////
    // 1. super init first
    if (!Layer::init())
    {
        return false;
    }

    log("stageScene %d, Stage %d", _stageScene, _stage);

    this->addChild(BackgroundLayer::create());

    return true;
}
