#include "GameScene.h"
#include "BackgroundLayer.h"

// Ķ͸  
static Node *_stageScene;
static int _stage;

//   , 0̸   ִº, 1̸ start, 2̸ goal, 3̸ , 4̸  
//[0][0] ȭ  Ʒ Ÿ, [3][4] ȭ   Ÿ
int STAGE1[4][5] = { { 0, 0, 0, 0, 0 }, { 0, 0, 0, 0, 0 }, { 0, 0, 0, 0, 0 }, { 0, 0, 0, 0, 0 } };
int STAGE2[4][5] = { { 0, 0, 0, 0, 0 }, { 0, 0, 0, 0, 0 }, { 0, 0, 0, 0, 0 }, { 0, 0, 0, 0, 0 } };
int STAGE3[4][5] = { { 0, 0, 0, 0, 0 }, { 0, 0, 0, 0, 0 }, { 0, 0, 0, 0, 0 }, { 0, 0, 0, 0, 0 } };

Scene* GameScene::createScene(Node *stageScene, int stage)
{
    _stageScene = stageScene;
    _stage = stage;

    // 'scene' is an autorelease object
    auto scene = Scene::create();

    // 'layer' is an autorelease object
    auto layer = GameScene::create();

    // add layer as a child to scene
    scene->addChild(layer);

    // return the scene
    return scene;
}

// on "init" you need to initialize your instance
bool GameScene::init()
{
    //////////////////////////////
    // 1. super init first
    if (!Layer::init())
    {
        return false;
    }

    log("stageScene %d, Stage %d", _stageScene, _stage);

    //ȭ ũ⸦ 
    auto winSize = Director::getInstance()->getOpenGLView()->getDesignResolutionSize();

    this->addChild(BackgroundLayer::create(), 0);

    _mapLayer = LayerColor::create(Color4B(0, 0, 0, 0), winSize.width, winSize.height);
    this->addChild(_mapLayer, 1);

    _menuLayer = LayerColor::create(Color4B(0, 0, 0, 0), winSize.width, winSize.height);
    this->addChild(_menuLayer, 2);

    //Stage  ٸ  迭 ̿ Ѵ.
    switch (_stage)
    {
    case 1:
        setMapLayer(STAGE1);
        break;
    case 2:
        setMapLayer(STAGE2);
        break;
    case 3:
        setMapLayer(STAGE3);
        break;
    }

    setMenuLayer();

    return true;
}

void GameScene::setMapLayer(int mapArr[4][5]){
    //2 for 鼭 ش 迭  ´.
    for (int i = 0; i < 4; i++){
        for (int j = 0; j < 5; j++){
            auto tile = getMaptile(i, j, mapArr[i][j]);
            _mapLayer->addChild(tile, 4 - i);
            //Ʒ ϰ  ϹǷ zOrder Ͽϴ.
        }
    }
}

LayerColor* GameScene::getMaptile(int row, int col, int type){
    auto tile = LayerColor::create(Color4B(255, 0, 0, 0), 96, 55);
    //row col ̿Ͽ ġ Ͽ.
    tile->setPosition(Point(col * tile->getContentSize().width, row * tile->getContentSize().height));

    //type 0̸
    if (type == 0){
        std::string iceImg;

        //row  ణ ٸ  ̹ ҷ´.
        switch (row)
        {
        case 0:
            iceImg = "ice_1.png";
            break;
        case 1:
            iceImg = "ice_2.png";
            break;
        case 2:
            iceImg = "ice_3.png";
            break;
        case 3:
            iceImg = "ice_4.png";
            break;
        }

        auto ice = Sprite::create(iceImg.c_str());
        ice->setPosition(Point(tile->getContentSize().width / 2, tile->getContentSize().height / 2));
        tile->addChild(ice);
    }

    // Ʒ tag 1   20 Ͽ 
    int tag = col + (5 * row) + 1;
    log("mapArr[%d][%d], tag = %d", row, col, tag);

    //Ÿ ġ tag ϱ  tag 
    tile->setTag(tag);

    return tile;
}

void GameScene::setMenuLayer(){

}