#include "GameScene.h"
#include "BackgroundLayer.h"
#include "GameoverPopup.h"
#include "PausePopup.h"
#include "ResultPopup.h"

//#define ʴ    ֽϴ.
//#define ݷ  ʽϴ.
#define RESCUE 5000
#define TILE 1000
#define TIME 30.00f
#define GOAL_BONUS 10000

// Ķ͸  
static Node *_stageScene;
static int _stage;

//   , 0̸   ִº, 1̸ start, 2̸ goal, 3̸ , 4̸  
//[0][0] ȭ  Ʒ Ÿ, [3][4] ȭ   Ÿ
int STAGE1[4][5] = { { 0, 0, 0, 3, 1 }, { 0, 3, 0, 0, 4 }, { 4, 0, 0, 0, 0 }, { 2, 0, 3, 0, 4 } };
int STAGE2[4][5] = { { 0, 3, 0, 0, 1 }, { 3, 0, 4, 0, 0 }, { 0, 0, 0, 4, 0 }, { 2, 0, 0, 0, 3 } };
int STAGE3[4][5] = { { 0, 0, 4, 0, 1 }, { 4, 3, 0, 3, 4 }, { 0, 0, 0, 0, 0 }, { 2, 0, 3, 0, 0 } };

Scene* GameScene::createScene(Node *stageScene, int stage)
{
    _stageScene = stageScene;
    _stage = stage;

    // 'scene' is an autorelease object
    auto scene = Scene::create();

    // 'layer' is an autorelease object
    auto layer = GameScene::create();

    // add layer as a child to scene
    scene->addChild(layer);

    // return the scene
    return scene;
}

// on "init" you need to initialize your instance
bool GameScene::init()
{
    //////////////////////////////
    // 1. super init first
    if (!Layer::init())
    {
        return false;
    }

    log("stageScene %d, Stage %d", _stageScene, _stage);

    //ȭ ũ⸦ 
    auto winSize = Director::getInstance()->getOpenGLView()->getDesignResolutionSize();

    this->addChild(BackgroundLayer::create(), 0);

    _mapLayer = LayerColor::create(Color4B(0, 0, 0, 0), winSize.width, winSize.height);
    this->addChild(_mapLayer, 1);

    _menuLayer = LayerColor::create(Color4B(0, 0, 0, 0), winSize.width, winSize.height);
    this->addChild(_menuLayer, 2);

    //Stage  ٸ  迭 ̿ Ѵ.
    switch (_stage)
    {
    case 1:
        setMapLayer(STAGE1);
        break;
    case 2:
        setMapLayer(STAGE2);
        break;
    case 3:
        setMapLayer(STAGE3);
        break;
    }

    setMenuLayer();

    return true;
}

void GameScene::setMapLayer(int mapArr[4][5]){
    //2 for 鼭 ش 迭  ´.
    for (int i = 0; i < 4; i++){
        for (int j = 0; j < 5; j++){
            auto tile = getMaptile(i, j, mapArr[i][j]);
            _mapLayer->addChild(tile, 4 - i);
            //Ʒ ϰ  ϹǷ zOrder Ͽϴ.
        }
    }
}

Menu* GameScene::getMaptile(int row, int col, int type){
    auto tile = LayerColor::create(Color4B(255, 0, 0, 0), 96, 55);

    auto tileMenu = MenuItemSprite::create(tile, NULL, CC_CALLBACK_1(GameScene::onClickTile, this));
    //row col ̿Ͽ ġ Ͽ.
    tileMenu->setPosition(Point(col * tile->getContentSize().width, row * tile->getContentSize().height));
    tileMenu->setAnchorPoint(Point(0, 0));

    //Ÿ ޴ __mapLayer Ͽ  tag Ͽ.
    tileMenu->setTag(1);

    auto menu = Menu::create(tileMenu, NULL);
    menu->setPosition(Point::ZERO);

    //type 0̰ų 1̰ų 3̸ Ϲ Ÿ, 1̳ 3 Ϲ Ÿ Ʈ ö󰡹Ƿ
    if (type == 0 || type == 1 || type == 3){
        std::string iceImg;

        //row  ణ ٸ  ̹ ҷ´.
        switch (row)
        {
        case 0:
            iceImg = "ice_1.png";
            break;
        case 1:
            iceImg = "ice_2.png";
            break;
        case 2:
            iceImg = "ice_3.png";
            break;
        case 3:
            iceImg = "ice_4.png";
            break;
        }

        auto ice = Sprite::create(iceImg.c_str());
        ice->setPosition(Point(tile->getContentSize().width / 2, tile->getContentSize().height / 2));
        ice->setTag(1);
        tile->addChild(ice);

        if (type == 1){
            //̹Ƿ ⿡ ϱذ ߰
            _polarbear = Polarbear::create(this, callfunc_selector(GameScene::polarbearAnimationFinish));
            _polarbear->setAnchorPoint(Point(0.5f, 0));

            //ϱذ mapLayer ߰ǹǷ m_tile ġ   .
            _polarbear->setPosition(Point(tileMenu->getPositionX() + tileMenu->getContentSize().width / 2, tileMenu->getPositionY() + tileMenu->getContentSize().height / 2));

            _mapLayer->addChild(_polarbear, 5);

            //ġ  Ÿ ־.
            _beforeIceTile = ice;
            _beforeIceTile->setTag(1);
        }
        else if (type == 3){
            // ߰
            auto penguin = getPenguinSprite();
            penguin->setAnchorPoint(Point(0.5f, 0));
            penguin->setPosition(Point(ice->getContentSize().width / 2, 25));
            ice->addChild(penguin);
        }
    }
    else if (type == 2){
        //type 2̸  
        auto ice = Sprite::create("goal.png");
        ice->setPosition(Point(tile->getContentSize().width / 2, tile->getContentSize().height / 2));
        ice->setTag(1);
        tile->addChild(ice);

        // ߰
        auto flag = getGoalFlagSprite();
        flag->setAnchorPoint(Point(0.5f, 0));
        flag->setPosition(Point(50, 35));
        ice->addChild(flag);
    }
    else if (type == 4){
        //type 4̸  Ÿ,  ӿ
        std::string iceImg;

        //row  ణ ٸ ̹ ҷ´.
        switch (row)
        {
        case 0:
            iceImg = "break1_default.png";
            break;
        case 1:
            iceImg = "break2_default.png";
            break;
        case 2:
            iceImg = "break3_default.png";
            break;
        case 3:
            iceImg = "break4_default.png";
            break;
        }

        auto breakIce = Sprite::create(iceImg.c_str());
        breakIce->setPosition(Point(tile->getContentSize().width / 2, tile->getContentSize().height / 2));
        breakIce->setTag(1);
        tile->addChild(breakIce);
    }

    // Ʒ tag 1   20 Ͽ 
    int tag = col + (5 * row) + 1;
    log("mapArr[%d][%d], tag = %d", row, col, tag);

    //Ÿ ġ tag ϱ  tag 
    menu->setTag(tag);

    //type 1̸ ϱذ ġϴ ̹Ƿ
    if (type == 1)
        _polarbearCurrentTag = tag;

    return menu;
}

void GameScene::setMenuLayer(){
    //ȭ ũ⸦ 
    auto winSize = Director::getInstance()->getOpenGLView()->getDesignResolutionSize();

    auto pause = MenuItemImage::create("btn_pause.png", "btn_pause_on.png", CC_CALLBACK_1(GameScene::onClickPause, this));
    pause->setPosition(Point(winSize.width - 20, winSize.height - 20));

    auto menu = Menu::create(pause, NULL);
    menu->setPosition(Point::ZERO);
    _menuLayer->addChild(menu);

    _score = 0;
    _rescueCount = 0;

    auto _scoreIcon = Sprite::create("score.png");
    _scoreIcon->setPosition(Point(30, winSize.height - 20));
    _menuLayer->addChild(_scoreIcon);

    _labelScore = LabelTTF::create("0", "arial", 20);
    _labelScore->setAnchorPoint(Point(0, 0.5f));
    _labelScore->setPosition(Point(60, winSize.height - 20));
    _menuLayer->addChild(_labelScore);

    auto penguinIcon = Sprite::create("icon_penguin.png");
    penguinIcon->setPosition(Point(140, winSize.height - 20));
    _menuLayer->addChild(penguinIcon);

    _labelPenguin = LabelTTF::create("0", "arial", 20);
    _labelPenguin->setPosition(Point(160, winSize.height - 20));
    _labelPenguin->setColor(Color3B(247, 136, 211));
    _menuLayer->addChild(_labelPenguin);

    auto timerBack = Sprite::create("time_bar.png");
    timerBack->setPosition(Point(80, winSize.height - 40));
    _menuLayer->addChild(timerBack);

    auto progressSprite = Sprite::create("time_gage.png");
    _progressBar = ProgressTimer::create(progressSprite);
    _progressBar->setPosition(Point(timerBack->getContentSize().width / 2 + 8, timerBack->getContentSize().height / 2));
    //α׷ٰ ϴ 
    _progressBar->setType(ProgressTimer::Type::BAR);
    //α׷ٰ ϴ , Point(1, 0)  width Ѵ.
    _progressBar->setBarChangeRate(Point(1, 0));
    //α׷ٰ  ߽ AnchorPoint 
    _progressBar->setMidpoint(Point(0, 0.5f));

    _progressBar->setPercentage(100);

    timerBack->addChild(_progressBar);

    _labelCountdown = LabelTTF::create("30.00", "Arial Bold", 10);
    _labelCountdown->setColor(Color3B::BLACK);
    _labelCountdown->setAnchorPoint(Point(0.5f, 0.5f));
    _labelCountdown->setPosition(Point(timerBack->getContentSize().width / 2 + 8, timerBack->getContentSize().height / 2 - 1));
    timerBack->addChild(_labelCountdown);

    setTimer();
}

// Ʈ 
Sprite* GameScene::getPenguinSprite(){
    // ϸ̼  ߰
    auto texture = TextureCache::getInstance()->addImage("penguin.png");
    float textureWidth = texture->getContentSize().width / 3;
    float textureHeight = texture->getContentSize().height;

    SpriteFrame *frame[3];

    frame[0] = SpriteFrame::createWithTexture(texture, Rect(0, 0, textureWidth, textureHeight));
    frame[1] = SpriteFrame::createWithTexture(texture, Rect(textureWidth * 1, 0, textureWidth, textureHeight));
    frame[2] = SpriteFrame::createWithTexture(texture, Rect(textureWidth * 2, 0, textureWidth, textureHeight));

    // Ʈ ߰
    auto penguin = Sprite::createWithSpriteFrame(frame[0]);
    penguin->setTag(1);

    //Ͽ ϸ̼ ߰
    Vector<SpriteFrame*> AniFrames;
    AniFrames.pushBack(frame[0]);
    AniFrames.pushBack(frame[1]);
    AniFrames.pushBack(frame[2]);

    auto animation = Animation::createWithSpriteFrames(AniFrames);
    animation->setDelayPerUnit(0.3f);
    auto animate = Animate::create(animation);

    penguin->runAction(RepeatForever::create(animate));

    //Ͽ ö ߰
    auto cage = Sprite::create("cage.png");
    cage->setTag(1);
    cage->setPosition(Point(penguin->getContentSize().width / 2, 20));
    penguin->addChild(cage);

    //help ޽ ߰
    auto help = Sprite::create("help.png");
    help->setAnchorPoint(Point(0.5f, 0));
    help->setPosition(Point(17, 40));
    penguin->addChild(help);

    //help ޽ ϸ̼ ߰
    //ϸ̼ ʱȭ
    auto action1 = Spawn::createWithTwoActions(ScaleTo::create(0, 0.5f), FadeTo::create(0, 0));
    // ϸ̼
    auto action2 = Spawn::createWithTwoActions(ScaleTo::create(0.5f, 1), FadeTo::create(0.4f, 100));
    //ϸ̼ ߰Ѵ.
    auto action = Sequence::createWithTwoActions(action1, action2);
    //ϸ̼ ݺŴ
    help->runAction(RepeatForever::create(action));

    return penguin;
}

// Ʈ 
Sprite* GameScene::getGoalFlagSprite(){
    // ϸ̼  ߰
    SpriteFrame *frame[3];

    frame[0] = SpriteFrame::create("flag_1.png", Rect(0, 0, 39, 53));
    frame[1] = SpriteFrame::create("flag_2.png", Rect(0, 0, 39, 53));
    frame[2] = SpriteFrame::create("flag_3.png", Rect(0, 0, 39, 53));

    // Ʈ ߰
    auto flag = Sprite::createWithSpriteFrame(frame[0]);

    //߿ ϸ̼ ߰
    Vector<SpriteFrame*> AniFrames;
    AniFrames.pushBack(frame[0]);
    AniFrames.pushBack(frame[1]);
    AniFrames.pushBack(frame[2]);

    auto animation = Animation::createWithSpriteFrames(AniFrames);
    animation->setDelayPerUnit(0.1f);
    auto animate = Animate::create(animation);

    flag->runAction(RepeatForever::create(animate));

    return flag;
}

void GameScene::onClickTile(Ref *object){
    auto tile = (MenuItem *)object;
    log("tag = %d", tile->getParent()->getTag());

    bool isMove = checkTileMove(tile->getParent()->getTag(), _polarbearCurrentTag);

    //̵ Ұ Ÿ ϸ return ع.
    if (isMove == false || tile->getParent()->getTag() < 0)
        return;

    //ϱذ ϸ̼ 
    bool result = _polarbear->setMoveTo(Point(tile->getPositionX() + tile->getContentSize().width / 2, tile->getPositionY() + tile->getContentSize().height / 2));

    if (result){
        //ϱذ ִ Ÿ sprite fadeoutϸ̼ ߰־.
        _beforeIceTile->runAction(FadeOut::create(1));

        //tag -1 Ͽϴ. menu > tile > tile normal ̹ > beforeIceTile  ڽĳ尡 Ǿִ.
        // menu tag ؾ ϹǷ beforeIceTile->getParent()->getParent()->getParent() ȣ menu Դ.
        _beforeIceTile->getParent()->getParent()->getParent()->setTag(-1);

        //MenuItem tag 1 normal, 2 select, 3 disable̹ Ǿִ.
        // tile 1 tag  ڽ  normal ̹ 带 Դ.
        // 忡 1 tag  ڽĳ带 ٽð  sprite Դ.
        _beforeIceTile = (Sprite *)tile->getChildByTag(1)->getChildByTag(1);

        //ϱذ tag
        _polarbearCurrentTag = tile->getParent()->getTag();
    }
}

bool GameScene::checkTileMove(int tileTag, int bearTag){
    log("tag = %d", tileTag);

    //tag Ͽ col row Ѵ.
    int col = (tileTag - 1) % 5;
    int row = (tileTag - 1 - col) / 5;

    log("col = %d, row = %d", col, row);

    //ϱذ  ġ tag Ͽ col row Ѵ.
    log("polarbear_current_tag = %d", bearTag);

    int bearCol = (bearTag - 1) % 5;
    int bearRow = (bearTag - 1 - bearCol) / 5;

    log("bearCol = %d, bearRow = %d", bearCol, bearRow);
    if (tileTag == bearTag){
        //ϱذ ġδ ̵ Ұϴ.
        log("move false");
        return false;
    }
    else if ((col <= bearCol + 1 && col >= bearCol - 1) && (row <= bearRow + 1 && row >= bearRow - 1)){
        //̵  üũѴ. ϱذ ġŸ col +- 1 ġؾϸ row +- 1 ġ  ̵
        if (!(col == bearCol - 1 && row == bearRow + 1) && !(col == bearCol - 1 && row == bearRow - 1) && !(col == bearCol + 1 && row == bearRow - 1) && !(col == bearCol + 1 && row == bearRow + 1)){
            //밢 κ ƴϸ ̵ ϴ.
            log("move true");
            return true;
        }
        else{
            //밢 κ̸ ̵ Ұϴ.
            log("move false");
            return false;
        }
    }
    else{
        //̵ Ұ  Ÿ̴.
        log("move false");
        return false;
    }
}

void GameScene::polarbearAnimationFinish(){
    log("polarbearAnimationFinish");

    //tag Ͽ col row Ѵ.
    int col = (_polarbearCurrentTag - 1) % 5;
    int row = (_polarbearCurrentTag - 1 - col) / 5;

    log("col = %d, row = %d", col, row);

    int type = getTileType(col, row);
    log("type = %d", type);

    switch (type)
    {
    case 0:		//Ϲ 
        _score = _score + TILE;
        break;
    case 2:		// 
        _score = _score + TILE;

        stopTimer();
        // Ͽ GOAL_BONUS ߰־ϴ.
        _score = _score + ((_countdownTimer / TIME) * GOAL_BONUS);

        {
            auto UserDefault = UserDefault::getInstance();

            if (_stage == 1)
                UserDefault->setBoolForKey("lock2", false);
            else if (_stage == 2)
                UserDefault->setBoolForKey("lock3", false);

            //ȣ־  ٲ.
            UserDefault->flush();
        }

        this->addChild(ResultPopup::create(_score, _rescueCount), 99);
        break;
    case 3:		// 
    {
        _score = _score + RESCUE;
        _rescueCount = _rescueCount + 1;

        auto ice = (Sprite *)_mapLayer->getChildByTag(_polarbearCurrentTag)->getChildByTag(1)->getChildByTag(1)->getChildByTag(1);
        auto penguin = (Sprite *)ice->getChildByTag(1);
        //ŸϿ 1 tag  ڽĳ  Ʈ
        auto cage = (Sprite *)penguin->getChildByTag(1);
        // Ʈ 1  ڽĳ  Ʈ

        int multiplication = 1;
        float random = CCRANDOM_MINUS1_1();

        if (random < 0)
            multiplication = -1;

        auto move = MoveBy::create(0.5f, Point(200 * multiplication, 100));

        auto scale = ScaleTo::create(0.5f, 5);
        auto rotate = RotateBy::create(0.5f, 360);
        auto fade = FadeOut::create(0.5f);

        auto action = Spawn::create(move, scale, rotate, fade, NULL);
        cage->runAction(Sequence::createWithTwoActions(action, CallFuncN::create(CC_CALLBACK_1(GameScene::removeMe, this))));

        penguin->runAction(Sequence::createWithTwoActions(DelayTime::create(0.5), CallFuncN::create(CC_CALLBACK_1(GameScene::removeMe, this))));

        _polarbear->setPenguin();
        break;
    }
    case 4:		//̰ 
        stopTimer();

        runIceBreakAnimation((Sprite *)_mapLayer->getChildByTag(_polarbearCurrentTag)->getChildByTag(1)->getChildByTag(1)->getChildByTag(1));
        _polarbear->fallSea(this, callfunc_selector(GameScene::fallSeaCallBack));
        break;
    }

    char c_score[50];
    sprintf(c_score, "%d", _score);
    _labelScore->setString(c_score);

    char c_rescue[20];
    sprintf(c_rescue, "%d", _rescueCount);
    _labelPenguin->setString(c_rescue);
}

int GameScene::getTileType(int col, int row){
    int type;

    switch (_stage)
    {
    case 1:
        type = STAGE1[row][col];
        break;
    case 2:
        type = STAGE2[row][col];
        break;
    case 3:
        type = STAGE3[row][col];
        break;
    }

    return type;
}

//  ϸ̼ Ű ޼ҵ
void GameScene::runIceBreakAnimation(Sprite *ice){
    std::string iceImg;

    int row = (ice->getParent()->getParent()->getParent()->getTag() - 1) / 5;
    // tag ̿Ͽ row ־.
    switch (row)
    {
    case 0:
        iceImg = "break1.png";
        break;
    case 1:
        iceImg = "break2.png";
        break;
    case 2:
        iceImg = "break3.png";
        break;
    case 3:
        iceImg = "break4.png";
        break;
    }

    auto texture = TextureCache::getInstance()->addImage(iceImg.c_str());
    float textureWidth = texture->getContentSize().width / 5;
    float textureHeight = texture->getContentSize().height;

    SpriteFrame *frame[5];

    frame[0] = SpriteFrame::createWithTexture(texture, Rect(0, 0, textureWidth, textureHeight));
    frame[1] = SpriteFrame::createWithTexture(texture, Rect(textureWidth * 1, 0, textureWidth, textureHeight));
    frame[2] = SpriteFrame::createWithTexture(texture, Rect(textureWidth * 2, 0, textureWidth, textureHeight));
    frame[3] = SpriteFrame::createWithTexture(texture, Rect(textureWidth * 3, 0, textureWidth, textureHeight));
    frame[4] = SpriteFrame::createWithTexture(texture, Rect(textureWidth * 4, 0, textureWidth, textureHeight));

    Vector<SpriteFrame*> AniFrames;
    AniFrames.pushBack(frame[0]);
    AniFrames.pushBack(frame[1]);
    AniFrames.pushBack(frame[2]);
    AniFrames.pushBack(frame[3]);
    AniFrames.pushBack(frame[4]);

    auto animation = Animation::createWithSpriteFrames(AniFrames);
    animation->setDelayPerUnit(0.1f);
    auto animate = Animate::create(animation);

    ice->runAction(animate);
}

void GameScene::fallSeaCallBack(){
    log("fallSeaCallBack");

    this->addChild(GameoverPopup::create(), 99);
}

void GameScene::onClickPause(Ref *object){
    log("onClickPause");
	
    pauseTimer();

    this->addChild(PausePopup::create(), 99);
}

void GameScene::restartGame(){
    log("restartGame");

    resumeTimer();

    _mapLayer->removeAllChildrenWithCleanup(true);
    _menuLayer->removeAllChildrenWithCleanup(true);

    //Stage  ٸ  迭 ̿ Ѵ.
    switch (_stage)
    {
    case 1:
        setMapLayer(STAGE1);
        break;
    case 2:
        setMapLayer(STAGE2);
        break;
    case 3:
        setMapLayer(STAGE3);
        break;
    }

    setMenuLayer();
}

void GameScene::removeMe(Node *node){
    node->removeFromParentAndCleanup(true);
}

void GameScene::setTimer(){
    _progressBar->runAction(ProgressFromTo::create(TIME, 100, 0));

    _countdownTimer = TIME;
    schedule(schedule_selector(GameScene::updateTimer));
}

void GameScene::updateTimer(float time){
    _countdownTimer -= time;
    if (_countdownTimer < 0){
        _countdownTimer = 0;
        unschedule(schedule_selector(GameScene::updateTimer));
        _labelCountdown->setString("0.0");

        this->addChild(GameoverPopup::create(), 99);
    }

    log("_countDownTimer : %f", _countdownTimer);
    char str[10] = { 0 };
    //Ҽ °ڸ ǥѴ.
    sprintf(str, "%2.2f", _countdownTimer);
    _labelCountdown->setString(str);
}

void GameScene::stopTimer(){
    unschedule(schedule_selector(GameScene::updateTimer));
    _progressBar->stopAllActions();
}

void GameScene::pauseTimer(){
    this->pauseSchedulerAndActions();
    _progressBar->pauseSchedulerAndActions();
}

void GameScene::resumeTimer(){
    this->resumeSchedulerAndActions();
    _progressBar->resumeSchedulerAndActions();
}
