#include "RankingPopup.h"

RankingPopup * RankingPopup::create(){
    RankingPopup *ret = new RankingPopup();
    if (ret && ret->init())
    {
        ret->autorelease();
    }
    else
    {
        CC_SAFE_DELETE(ret);
    }

    return ret;
}

bool RankingPopup::init(){
    //⿡ ˾ ۼѴ.

    //Device ũ⸦ ɴϴ.
    auto winSize = Director::getInstance()->getOpenGLView()->getDesignResolutionSize();

    auto fadeBack = LayerColor::create(Color4B(0, 0, 0, 0), winSize.width, winSize.height);
    this->addChild(fadeBack);
    fadeBack->runAction(FadeTo::create(0.5f, 200));

    auto back = Sprite::create("pop_rank.png");
    back->setPosition(Point(winSize.width / 2, winSize.height / 2));
    this->addChild(back);

    auto okMenu = MenuItemImage::create("btn_ok.png", "btn_ok_on.png", CC_CALLBACK_1(RankingPopup::onClickOk, this));
    okMenu->setPosition(Point(back->getContentSize().width / 2, 10));

    auto menu = Menu::create(okMenu, NULL);
    menu->setPosition(Point::ZERO);
    back->addChild(menu);

    return true;
}

void RankingPopup::onEnter(){
    Layer::onEnter();

    setTouchEnabled(true);
    setTouchMode(Touch::DispatchMode::ONE_BY_ONE);
}

bool RankingPopup::onTouchBegan(Touch* touch, Event* event){
    return true;
}

void RankingPopup::onClickOk(Ref *object){
    this->removeFromParentAndCleanup(true);
}
