#include "Polarbear.h"

Polarbear::Polarbear(void)
{
    //layer ũ⸦ ش.
    this->setContentSize(Size(43, 70));
    this->setAnchorPoint(Point(0.5f, 0));
    this->ignoreAnchorPointForPosition(false);
    //Layer LayerColor  AnchorPoint  ؼ ignoreAnchorPointForPosition(false) ־ Ѵ.
    // Layer Scene Point(0, 0) Ǿ ֱ  ⺻ AnchorPoint Point(0, 0)̴.

    _isAnimation = false;
}

Polarbear::~Polarbear(void)
{
    _wait->release();
    _jumpLeft->release();
    _jumpTop->release();
    _jumpBottom->release();
}

Polarbear * Polarbear::create(){
    Polarbear *ret = new Polarbear();
    if (ret && ret->init())
    {
        ret->autorelease();
    }
    else
    {
        CC_SAFE_DELETE(ret);
    }

    return ret;
}

bool Polarbear::init(){
    {
        // ϸ̼  / ߰
        SpriteFrame *frame[6];

        //1->2->3->4->2->1  ̹ ݺ
        frame[0] = SpriteFrame::create("w_bear01.png", Rect(0, 0, 43, 70));
        frame[1] = SpriteFrame::create("w_bear02.png", Rect(0, 0, 43, 70));
        frame[2] = SpriteFrame::create("w_bear03.png", Rect(0, 0, 43, 70));
        frame[3] = SpriteFrame::create("w_bear04.png", Rect(0, 0, 43, 70));
        frame[4] = SpriteFrame::create("w_bear02.png", Rect(0, 0, 43, 70));
        frame[5] = SpriteFrame::create("w_bear01.png", Rect(0, 0, 43, 70));

        //Ʈ ߰
        _polarbear = Sprite::createWithSpriteFrame(frame[0]);
        _polarbear->setPosition(Point(this->getContentSize().width / 2, this->getContentSize().height / 2));
        this->addChild(_polarbear);

        // Array ߰
        Vector<SpriteFrame*> AniFrames;
        AniFrames.pushBack(frame[0]);
        AniFrames.pushBack(frame[1]);
        AniFrames.pushBack(frame[2]);
        AniFrames.pushBack(frame[3]);
        AniFrames.pushBack(frame[4]);
        AniFrames.pushBack(frame[5]);

        auto animation = Animation::createWithSpriteFrames(AniFrames);
        animation->setDelayPerUnit(0.3f);
        _wait = RepeatForever::create(Animate::create(animation));
        _wait->retain();

        //⿡ϸ̼ 
        _polarbear->runAction(_wait);
    }
	
    {
        //  ϸ̼  / ߰
        SpriteFrame *frame[5];

        //2->5->6->7->5  1 
        frame[0] = SpriteFrame::create("w_bear02.png", Rect(0, 0, 43, 70));
        frame[1] = SpriteFrame::create("w_bear05.png", Rect(0, 0, 43, 70));
        frame[2] = SpriteFrame::create("w_bear06.png", Rect(0, 0, 43, 70));
        frame[3] = SpriteFrame::create("w_bear07.png", Rect(0, 0, 43, 70));
        frame[4] = SpriteFrame::create("w_bear05.png", Rect(0, 0, 43, 70));

        // Array ߰
        Vector<SpriteFrame*> AniFrames;
        AniFrames.pushBack(frame[0]);
        AniFrames.pushBack(frame[1]);
        AniFrames.pushBack(frame[2]);
        AniFrames.pushBack(frame[3]);
        AniFrames.pushBack(frame[4]);

        auto animation = Animation::createWithSpriteFrames(AniFrames);
        animation->setDelayPerUnit(0.2f);
        _jumpLeft = Animate::create(animation);
        _jumpLeft->retain();
    }

    {
        //  ϸ̼  / ߰
        SpriteFrame *frame[3];

        //11->12->13  1 
        frame[0] = SpriteFrame::create("w_bear11.png", Rect(0, 0, 43, 70));
        frame[1] = SpriteFrame::create("w_bear12.png", Rect(0, 0, 43, 70));
        frame[2] = SpriteFrame::create("w_bear13.png", Rect(0, 0, 43, 70));

        // Array ߰
        Vector<SpriteFrame*> AniFrames;
        AniFrames.pushBack(frame[0]);
        AniFrames.pushBack(frame[1]);
        AniFrames.pushBack(frame[2]);

        auto animation = Animation::createWithSpriteFrames(AniFrames);
        animation->setDelayPerUnit(0.33f);
        _jumpTop = Animate::create(animation);
        _jumpTop->retain();
    }

    {
        //Ʒ  ϸ̼  / ߰
        SpriteFrame *frame[3];

        //8->9->10  1 
        frame[0] = SpriteFrame::create("w_bear08.png", Rect(0, 0, 43, 70));
        frame[1] = SpriteFrame::create("w_bear09.png", Rect(0, 0, 43, 70));
        frame[2] = SpriteFrame::create("w_bear10.png", Rect(0, 0, 43, 70));

        // Array ߰
        Vector<SpriteFrame*> AniFrames;
        AniFrames.pushBack(frame[0]);
        AniFrames.pushBack(frame[1]);
        AniFrames.pushBack(frame[2]);

        auto animation = Animation::createWithSpriteFrames(AniFrames);
        animation->setDelayPerUnit(0.33f);
        _jumpBottom = Animate::create(animation);
        _jumpBottom->retain();
    }

    return true;
}

void Polarbear::setAnimation(int type){
    // Ʈ ϸ̼ .
    _polarbear->stopAllActions();

    switch (type)
    {
    case 0:
        _polarbear->runAction(_wait);
        _isAnimation = false;
        break;
    case 1:
        _polarbear->setFlipX(false);
        _polarbear->runAction(Sequence::createWithTwoActions((ActionInterval *)_jumpLeft, CallFunc::create(CC_CALLBACK_0(Polarbear::setWait, this))));
        break;
    case 2:
        _polarbear->setFlipX(true);
        _polarbear->runAction(Sequence::createWithTwoActions((ActionInterval *)_jumpLeft, CallFunc::create(CC_CALLBACK_0(Polarbear::setWait, this))));
        break;
    case 3:
        _polarbear->runAction(Sequence::createWithTwoActions((ActionInterval *)_jumpTop, CallFunc::create(CC_CALLBACK_0(Polarbear::setWait, this))));
        break;
    case 4:
        _polarbear->runAction(Sequence::createWithTwoActions((ActionInterval *)_jumpBottom, CallFunc::create(CC_CALLBACK_0(Polarbear::setWait, this))));
        break;
    }
}

bool Polarbear::setMoveTo(Point moveTo){
    if (_isAnimation)
        return false;

    _isAnimation = true;

    auto action = JumpTo::create(1, moveTo, 20, 1);
    this->runAction(action);

    Point beforePoint = this->getPosition();

    if (beforePoint.x > moveTo.x)
        setAnimation(1);
    else if (beforePoint.x < moveTo.x)
        setAnimation(2);
    else if (beforePoint.y < moveTo.y)
        setAnimation(3);
    else if (beforePoint.y > moveTo.y)
        setAnimation(4);

    return true;
}

void Polarbear::setWait(){
    setAnimation(0);
}