#include "cocos2d.h"
#include "Polarbear.h"

USING_NS_CC;

class GameScene : public cocos2d::Layer
{
public:
    // there's no 'id' in cpp, so we recommend returning the class instance pointer
    static cocos2d::Scene* createScene(Node *stageScene, int stage);

    // Here's a difference. Method 'init' in cocos2d-x returns bool, instead of returning 'id' in cocos2d-iphone
    virtual bool init();

    // implement the "static create()" method manually
    CREATE_FUNC(GameScene);

    LayerColor *_mapLayer;
    LayerColor *_menuLayer;

    void setMapLayer(int mapArr[4][5]);
    Menu* getMaptile(int row, int col, int type);
    void setMenuLayer();

    Sprite *getPenguinSprite();
    Sprite *getGoalFlagSprite();

    Polarbear *_polarbear;

    void onClickTile(Ref *object);

    int _polarbearCurrentTag;
    bool checkTileMove(int tileTag, int bearTag);

    Sprite *_beforeIceTile;

    void polarbearAnimationFinish();

    int getTileType(int col, int row);

    void runIceBreakAnimation(Sprite *ice);

    void fallSeaCallBack();

    void onClickPause(Ref *object);

    void restartGame();
};
