#include "NamePopup.h"
#include "RankingPopup.h"

NamePopup * NamePopup::create(){
    NamePopup *ret = new NamePopup();
    if (ret && ret->init())
    {
        ret->autorelease();
    }
    else
    {
        CC_SAFE_DELETE(ret);
    }

    return ret;
}

bool NamePopup::init(){
    //⿡ ˾ ۼѴ.

    //ȭ ũ⸦ 
    auto winSize = Director::getInstance()->getOpenGLView()->getDesignResolutionSize();

    auto fadeBack = LayerColor::create(Color4B(0, 0, 0, 0), winSize.width, winSize.height);
    this->addChild(fadeBack);
    fadeBack->runAction(FadeTo::create(0.5f, 200));

    // ߰
    std::string text = "̸ Է ּ.";
    //ڿ  
    char utf8Text[255];

#if(CC_TARGET_PLATFORM == CC_PLATFORM_WIN32)
    //win32 utf-8
    wchar_t* wChar;

    wChar = new WCHAR[255];

    //wChar text ´.
    MultiByteToWideChar(CP_ACP, 0, text.c_str(), strlen(text.c_str()) + 1, wChar, 255);

    //wChar ڵϿ utf8Text ´.
    WideCharToMultiByte(CP_UTF8, 0, wChar, -1, utf8Text, 1024, NULL, NULL);
#endif

    //Android iPhone  ڵ ϸ ѱ ˴ϴ.
#if(CC_TARGET_PLATFORM != CC_PLATFORM_WIN32)
    //win32 ƴϸ utf8Text  text ִ´. 
    sprintf(utf8Text, "%s", text.c_str());
#endif

    auto noti = LabelTTF::create(utf8Text, "Arial", 25);

    noti->setPosition(Point(winSize.width / 2, winSize.height / 2 + 50));
    this->addChild(noti);

    //Ʈ ڽ ߰
    _nameEdit = EditBox::create(Size(200, 50), Scale9Sprite::create("yellow_edit.png"));
    _nameEdit->setPosition(Point(winSize.width / 2, winSize.height / 2));

    _nameEdit->setFontSize(25);
    _nameEdit->setFontColor(Color3B::RED);
    _nameEdit->setPlaceHolder("Name:");
    _nameEdit->setPlaceholderFontColor(Color3B::WHITE);
    _nameEdit->setMaxLength(8);
    _nameEdit->setReturnType(EditBox::KeyboardReturnType::DONE);
    _nameEdit->setDelegate(this);
    this->addChild(_nameEdit);

    //ư ߰
    auto okMenu = MenuItemImage::create("btn_ok.png", "btn_ok_on.png", CC_CALLBACK_1(NamePopup::onClickOK, this));
    okMenu->setPosition(Point(winSize.width / 2, winSize.height / 2 - 50));

    auto menu = Menu::create(okMenu, NULL);
    menu->setPosition(Point::ZERO);
    this->addChild(menu);

    return true;
}

void NamePopup::onEnter(){
    Layer::onEnter();

    setTouchEnabled(true);
    setTouchMode(Touch::DispatchMode::ONE_BY_ONE);
}

bool NamePopup::onTouchBegan(Touch* touch, Event* event){
    return true;
}

void NamePopup::editBoxEditingDidBegin(cocos2d::extension::EditBox* editBox)
{
    log("editBox %p DidBegin !", editBox);
}

void NamePopup::editBoxEditingDidEnd(cocos2d::extension::EditBox* editBox)
{
    log("editBox %p DidEnd !", editBox);
}

void NamePopup::editBoxTextChanged(cocos2d::extension::EditBox* editBox, const std::string& text)
{
    log("editBox %p TextChanged, text: %s ", editBox, text.c_str());
}

void NamePopup::editBoxReturn(EditBox* editBox)
{
    log("editBox %p was returned !", editBox);
}

void NamePopup::onClickOK(Ref *object){
    if (strcmp(_nameEdit->getText(), "") == 0){
        //̸  Է¹
        MessageBox("̸ ԷϽñ ٶϴ.", "");
        return;
    }

    auto UserDefault = UserDefault::getInstance();
    UserDefault->setStringForKey("name", _nameEdit->getText());
    //flush() ־ ˴ϴ.
    UserDefault->flush();

    //ŷ˾ ȣѴ.
    this->getParent()->addChild(RankingPopup::create());

    this->removeFromParentAndCleanup(true);
}
