#include "ResultPopup.h"
#include "SimpleAudioEngine.h"

ResultPopup * ResultPopup::create(int score, int penguin){
    ResultPopup *ret = new ResultPopup();
    if (ret && ret->init(score, penguin))
    {
        ret->autorelease();
    }
    else
    {
        CC_SAFE_DELETE(ret);
    }

    return ret;
}

bool ResultPopup::init(int score, int penguin){
    //⿡ ˾ ۼѴ.

    //ȭ ũ⸦ 
    auto winSize = Director::getInstance()->getOpenGLView()->getDesignResolutionSize();

    auto fadeBack = LayerColor::create(Color4B(0, 0, 0, 0), winSize.width, winSize.height);
    this->addChild(fadeBack);
    fadeBack->runAction(FadeTo::create(0.5f, 200));

    auto back = Sprite::create("pop_up.png");
    back->setTag(1);
    back->setPosition(Point(winSize.width / 2, winSize.height / 2));
    this->addChild(back);

    // Ʈ ߰
    auto pen1 = Sprite::create("score_penguin2.png");
    pen1->setTag(0);
    pen1->setPosition(Point(back->getContentSize().width / 2 - 50, 150));
    back->addChild(pen1);

    auto pen2 = Sprite::create("score_penguin2.png");
    pen2->setTag(1);
    pen2->setPosition(Point(back->getContentSize().width / 2, 160));
    back->addChild(pen2);

    auto pen3 = Sprite::create("score_penguin2.png");
    pen3->setTag(2);
    pen3->setPosition(Point(back->getContentSize().width / 2 + 50, 150));
    back->addChild(pen3);

    //Score
    auto scoreBg = Sprite::create("box_score.png");
    scoreBg->setPosition(Point(back->getContentSize().width / 2, 90));
    back->addChild(scoreBg);

    auto okMenu = MenuItemImage::create("btn_ok.png", "btn_ok_on.png", CC_CALLBACK_1(ResultPopup::onClickOK, this));
    okMenu->setPosition(Point(back->getContentSize().width / 2, 33));

    auto menu = Menu::create(okMenu, NULL);
    menu->setPosition(Point::ZERO);
    back->addChild(menu);

    //ھ ߰
    _labelScore = LabelTTF::create("0", "Arial", 40);
    _labelScore->setPosition(Point(scoreBg->getContentSize().width / 2, 25));
    _labelScore->setColor(Color3B(25, 163, 242));
    scoreBg->addChild(_labelScore);

    _totalScore = score;
    _tempScore = 0;
    _tickScore = score / 60;
    _updateCount = 0;

    _penguinCount = penguin;

    this->schedule(schedule_selector(ResultPopup::updateScore), 3.0f / 60, 59, 0.05f);

    auto UserDefault = CCUserDefault::getInstance();
    bool isSound = UserDefault->getBoolForKey("isSound", true);

    if (isSound){
        //  ߰ ȿ Ų.
        CocosDenshion::SimpleAudioEngine::getInstance()->pauseBackgroundMusic();
        CocosDenshion::SimpleAudioEngine::getInstance()->playEffect("sound/score.wav");
    }

    return true;
}

void ResultPopup::onEnter(){
    Layer::onEnter();

    setTouchEnabled(true);
    setTouchMode(Touch::DispatchMode::ONE_BY_ONE);
}

bool ResultPopup::onTouchBegan(Touch* touch, Event* event){
    return true;
}

void ResultPopup::onClickOK(Ref *object){
    auto UserDefault = CCUserDefault::getInstance();
    bool isSound = UserDefault->getBoolForKey("isSound", true);

    if (isSound){
        // ٽ Ų.
        CocosDenshion::SimpleAudioEngine::getInstance()->resumeBackgroundMusic();
    }

    Director::getInstance()->popScene();
}

void ResultPopup::updateScore(float time){
    _updateCount++;

    _tempScore = _tempScore + _tickScore;
    char scoreChar[50];

    //60°ȣ⺸ ũ totalScore ־ش.
    if (_updateCount >= 60){
        sprintf(scoreChar, "%d", _totalScore);
        // Ѵ.
        unschedule(schedule_selector(ResultPopup::updateScore));

        auto scaleTo = ScaleTo::create(0.1f, 1.2);
        _labelScore->runAction(scaleTo);

        setPenguinCount();
    }
    else
        sprintf(scoreChar, "%d", _tempScore);

    _labelScore->setString(scoreChar);
}

void ResultPopup::setPenguinCount(){
    auto back = (Sprite *)this->getChildByTag(1);

    for (int i = 0; i < _penguinCount; i++){
        auto penguin = (Sprite *)back->getChildByTag(i);

        auto getPenguin = Sprite::create("score_penguin1.png");
        getPenguin->setPosition(penguin->getPosition());
        back->addChild(getPenguin);

        //scale 0 
        getPenguin->setScale(0);

        //̽ð 0.5ʰ
        auto delay = DelayTime::create(i * 0.5f);
        //0.1ʵ scale 1 ϸ̼
        auto ScaleTo = ScaleTo::create(0.1f, 1);

        auto action = Sequence::create(delay, ScaleTo, CallFuncN::create(CC_CALLBACK_1(ResultPopup::setParticle, this)), NULL);

        getPenguin->runAction(action);

        getPenguin->setTag(i);
    }
}

void ResultPopup::setParticle(Node *node){
    //ƼŬ ߰
    auto UserDefault = UserDefault::getInstance();
    bool isSound = UserDefault->getBoolForKey("isSound", true);

    if (isSound){
        //ȿ ణ ٸ ֱؼ tag ޾ ȿ 
        if (node->getTag() == 0)
            CocosDenshion::SimpleAudioEngine::getInstance()->playEffect("sound/firework1.mp3");
        else if (node->getTag() == 1)
            CocosDenshion::SimpleAudioEngine::getInstance()->playEffect("sound/firework2.mp3");
        else if (node->getTag() == 2)
            CocosDenshion::SimpleAudioEngine::getInstance()->playEffect("sound/firework3.mp3");
    }

    //30 ڸ  ParticleExplosion  
    auto particle = ParticleExplosion::createWithTotalParticles(30);
    particle->setPosition(Point(node->getContentSize().width / 2, node->getContentSize().height / 2));

    //ؽĸ 
    particle->setTexture(TextureCache::getInstance()->addImage("star.png"));
    //ƼŬ ӵ
    particle->setSpeed(100);
    //ƼŬ    80% Ͽ.
    particle->setStartColor(Color4F(1, 1, 1, 0.80f));
    //ڵ ش.
    particle->setAutoRemoveOnFinish(true);

    node->addChild(particle);
}
