#include "RankingPopup.h"
#include "json\document.h"

RankingPopup * RankingPopup::create(){
    RankingPopup *ret = new RankingPopup();
    if (ret && ret->init())
    {
        ret->autorelease();
    }
    else
    {
        CC_SAFE_DELETE(ret);
    }

    return ret;
}

bool RankingPopup::init(){
    //⿡ ˾ ۼѴ.

    //Device ũ⸦ ɴϴ.
    auto winSize = Director::getInstance()->getOpenGLView()->getDesignResolutionSize();

    auto fadeBack = LayerColor::create(Color4B(0, 0, 0, 0), winSize.width, winSize.height);
    this->addChild(fadeBack);
    fadeBack->runAction(FadeTo::create(0.5f, 200));

    auto back = Sprite::create("pop_rank.png");
    back->setPosition(Point(winSize.width / 2, winSize.height / 2));
    this->addChild(back);

    auto okMenu = MenuItemImage::create("btn_ok.png", "btn_ok_on.png", CC_CALLBACK_1(RankingPopup::onClickOk, this));
    okMenu->setPosition(Point(back->getContentSize().width / 2, 10));

    auto menu = Menu::create(okMenu, NULL);
    menu->setPosition(Point::ZERO);
    back->addChild(menu);

    //ε ؽƮ 
    _loading = LabelTTF::create("loading...", "Arial", 30);
    _loading->setColor(Color3B::YELLOW);
    _loading->setPosition(Point(back->getContentSize().width / 2, back->getContentSize().height / 2));
    back->addChild(_loading);

    // ȣ
    auto UserDefault = UserDefault::sharedUserDefault();
    std::string name = UserDefault->getStringForKey("name", "");
    int point1 = UserDefault->getIntegerForKey("point1", 0);	// 1 
    int point2 = UserDefault->getIntegerForKey("point2", 0);	// 2 
    int point3 = UserDefault->getIntegerForKey("point3", 0);	// 3 

    char url[255];
    //ipּҴ xampp ġ pc  ip ּҸ Էմϴ.
    sprintf(url, "http://192.168.0.2/gameapi/ranking.php?name=\"%s\"&point=%d", name.c_str(), point1 + point2 + point3);

    HttpRequest* request = new HttpRequest();
    // required fields
    request->setUrl(url);
    request->setRequestType(HttpRequest::Type::GET);
    request->setResponseCallback(this, httpresponse_selector(RankingPopup::onHttpRequestCompleted));
    // optional fields                            
    request->setTag("sendData");

    HttpClient::getInstance()->send(request);

    // don't forget to release it, pair to new
    request->release();

    // back ޴´.
    _back = back;

    return true;
}

void RankingPopup::onEnter(){
    Layer::onEnter();

    setTouchEnabled(true);
    setTouchMode(Touch::DispatchMode::ONE_BY_ONE);
}

bool RankingPopup::onTouchBegan(Touch* touch, Event* event){
    return true;
}

void RankingPopup::onClickOk(Ref *object){
    this->removeFromParentAndCleanup(true);
}

void RankingPopup::onHttpRequestCompleted(HttpClient *sender, HttpResponse *response)
{
    if (!response)
    {
        return;
    }

    // You can get original request type from: response->request->reqType
    if (0 != strlen(response->getHttpRequest()->getTag()))
    {
        log("%s completed", response->getHttpRequest()->getTag());
    }

    int statusCode = response->getResponseCode();
    char statusString[64] = {};
    sprintf(statusString, "HTTP Status Code: %d, tag = %s", statusCode, response->getHttpRequest()->getTag());

    log("response code: %d", statusCode);

    if (!response->isSucceed())
    {
        log("response failed");
        log("error buffer: %s", response->getErrorBuffer());
        return;
    }

    // dump data
    std::vector<char> *buffer = response->getResponseData();
    std::string text(buffer->begin(), buffer->end());
    log("%s", text.c_str());

    jsonParse(text);
}

void RankingPopup::jsonParse(std::string jsonText){
    _loading->removeFromParentAndCleanup(true);		//ε ؽƮ 

    rapidjson::Document document;

    //json Ľ
    // ˻   ִ Json ߵǾ ִ Ȯ մϴ.

    if (jsonText.c_str() != NULL && !document.Parse<2>(jsonText.c_str()).HasParseError())
    {
        // Ľ̿ 
        rapidjson::Value& root = document;

        for (int i = 0; i < root.Size(); i++){
            std::string Name = root[i]["NAME"].GetString();
            int point = root[i]["POINT"].GetInt();
            log("%s : %d", Name.c_str(), point);

            //ŷ ߰
            char rankChar[255];
            sprintf(rankChar, "%d.", i + 1);

            auto labelRanking = LabelTTF::create(rankChar, "Arial", 12);
            labelRanking->setColor(Color3B::BLACK);
            labelRanking->setPosition(Point(22, (_back->getContentSize().height - 50) - i * 22));
            _back->addChild(labelRanking);

            //г ߰
            char nickChar[255];
            sprintf(nickChar, "%s", Name.c_str());

            auto labelNick = LabelTTF::create(nickChar, "arial", 14);
            labelNick->setColor(Color3B::BLACK);
            labelNick->setPosition(Point(90, (_back->getContentSize().height - 50) - i * 22));
            _back->addChild(labelNick);

            // ߰
            char pointChar[255];
            sprintf(pointChar, "%d", point);

            auto labelPoint = LabelTTF::create(pointChar, "Arial", 10);
            labelPoint->setColor(Color3B::BLACK);
            labelPoint->setPosition(Point(180, (_back->getContentSize().height - 50) - i * 22));
            _back->addChild(labelPoint);
        }
    }
    else{
        // Ľ̿ 
        MessageBox("network error", "error");
        this->removeFromParentAndCleanup(true);
    }
}
